#declare BushSizeSeed = seed( 655 );
#declare BushPlaceSeed = seed( 36 );
#declare BushRotateSeed = seed( 756891 );
#declare BushParamScale = < 1, 1.75, 1>;

#declare TilleulSizeSeed = seed( 79230 );
#declare TilleulPlaceSeed = seed( 1234 );
#declare TilleulRotateSeed = seed( 4682 );

#macro PlaceXLineBushes(BushScale)
	#for( ItX, -40, 40, BushScale - 2 )
		#local Norm = < 0, 0, 0 >;
		#local StartPos = <ItX, 1000, 80 > + < rand(BushPlaceSeed) * BushScale / 4 - BushScale / 8, 0, rand(BushPlaceSeed) * BushScale / 4 - BushScale / 8 >;
		#local Position = trace( WholeGround, StartPos, -y, Norm );
		#if( Norm.x != 0 | Norm.y != 0 | Norm.z != 0 )
			object{ Bush 
					rotate rand(BushRotateSeed) * 360 * y 
					scale (BushScale - rand(BushSizeSeed) * 0.25 * BushScale) * BushParamScale 
					translate Position } 
		#end
	#end
#end

#macro PlaceZLineBushes(BushScale)
	#for( ItZ, -100, 80 - BushScale, BushScale - 2 )
		#local Norm = < 0, 0, 0 >;
		#local StartPos = < 40, 1000, ItZ > + < rand(BushPlaceSeed) * BushScale / 4 - BushScale / 8, 0, rand(BushPlaceSeed) * BushScale / 4 - BushScale / 8 >;
		#local Position = trace( WholeGround, StartPos, -y, Norm );
		#if( Norm.x != 0 | Norm.y != 0 | Norm.z != 0 )
			object{ Bush 
					rotate rand(BushRotateSeed) * 360 * y 
					scale (BushScale - rand(BushSizeSeed) * 0.25 * BushScale) * BushParamScale 
					translate Position } 
		#end
	#end
#end

#macro PlaceBushes()
	PlaceXLineBushes( 5 )
	PlaceZLineBushes( 5 )
#end

#macro PlaceTilleuls(TilleulScale)
	#for( ItX, min_extent(WholeGround).x, max_extent(WholeGround).x, TilleulScale )
		#for( ItZ, min_extent(WholeGround).z, max_extent(WholeGround).z, TilleulScale )
			#local Norm = < 0, 0, 0 >;
			#local StartPos = 	< ItX, 1000, ItZ > + 
								< 	rand(TilleulPlaceSeed) * TilleulScale / 4 - TilleulScale / 8, 0
									rand(TilleulPlaceSeed) * TilleulScale / 4 - TilleulScale / 8 >;
					#local Position = trace( WholeGround, StartPos, -y, Norm );
			#if( ( Position.x >= 40 | Position.z >= 80 ) & ( Norm.x != 0 | Norm.y != 0 | Norm.z != 0 ) )
				object{ Tilleul 
						rotate rand(TilleulRotateSeed) * 360 * y
						scale TilleulScale + TilleulScale * 0.5 * rand( TilleulSizeSeed )
						translate Position }
			#end
		#end
	#end
#end
