
#declare PumpkinsColors = array[4] { 	color srgb < 0, 0, 1 >, 
										color srgb 0.6, 
										color srgb < 1, 0.4, 0 >, 
										color srgb < 1, 1, 0> }

#declare BourletsNumber = 18;
#declare Bourlet = sphere{ 0, 0.95 scale <0.5, 1, 1> }
#declare PumpkinBody = union{
							#for( It, 0, BourletsNumber - 1 )
								object{ Bourlet rotate 360 / BourletsNumber * It * y}
							#end
						}
						

#declare TwistedMouthDiff = prism{ linear_sweep linear_spline 0, 5, 15
							< 0, 0>, < 1, 0>, < 1, -1>, < 2, -1>, < 2, -2>, < 3, -2>, < 3, -3>, < 4, -3>, < 4, -4>,
							< 2, -4>, < 2, -3>, < 1, -3>, < 1, -2>, < 0, -2>, < 0, 0> 
							translate < -2, 0, 2> scale 0.2}

							
#declare TeethLackMouth = prism{ linear_sweep linear_spline 0, 5, 19
                                 <1,1>,<1.25,0>,<2.75,-1.5>,<2.25,-2>,<2.75,-2.5>,<3.25,-2>,
                                 <5,-3>,<4,-3.5>,<3.25,-3.5>,<3.3,-3.1>,<2.5,-2.8>,<2.25,-3.4>,
                                 <1,-3>,<0.5,-2.15>,<1.15,-1.75>,<0.8,-1>,<0.3,-1.1>,<0.25,0>,
                                 <1,1>
                                 translate < -2, 0, 2> rotate 180*y scale 0.2
                          }						        
                          							
#declare EyeDiffPrism = prism{ linear_sweep linear_spline 0, 4, 4
							< -1, 0>, <0, 0>, < 0, -1>, < -1, 0> rotate -45*y rotate -90*x scale 0.3}

#declare EyeDiffCyl = cylinder{ < 0, 0.5, 0>, < 0, 0.5, -2>, 0.15 }
							
#macro MakePumpkin(PumpkinPosition, PumpkinRotation, PumpkinScale, EyeDiffIsCyl, PumpkinColor, MouthIsTwisted, LightInside)
    union{
	    difference{
		    object{ PumpkinBody }
		    sphere{ 0, 0.85 }
			
			#if( MouthIsTwisted )
				object{ TwistedMouthDiff rotate (-45 -180 )*y rotate -90*x translate < 0, -0.4, 0 > }
		    #else
		        object{ TeethLackMouth rotate (-45 - 180 )*y rotate -90*x translate < 0, -0.4, 0 > }
		    #end
		    #if( EyeDiffIsCyl )    
		        object{ EyeDiffCyl translate < -0.45, 0, 0 > }
		        object{ EyeDiffCyl translate <  0.45, 0, 0 > }
		    #else
		        object{ EyeDiffPrism translate < -0.35, 0.5, 0> }
		        object{ EyeDiffPrism translate < 0.35, 0.5, 0> }
		    #end
		    pigment{ PumpkinColor }
		    normal{ agate bump_size 0.45 }
		    finish{ specular 0.2 roughness 0.01 }
	    }
	    #if( LightInside )
	    sphere{ 0, 0.8 hollow no_shadow pigment{ color srgbft <0, 0, 0, 0, 1> }
		        interior{
		            media{
		                emission color srgb < 1, 0.5, 0 > samples 1,30 intervals 2
		            }
		        }
		}
			light_source{ < 0, 0.25, 0 >  color srgb < 1.5, 1, 0> }
		#end
		translate 0.95 * y
		scale PumpkinScale
		rotate PumpkinRotation
		translate PumpkinPosition
    }
#end
